/*
 * Copyright (c) 2007 Samsung Electronics Co., Ltd. All rights reserved. 
 */

#ifndef ANDROID_JACK_CLIENT_INTERFACEV2_H
#define ANDROID_JACK_CLIENT_INTERFACEV2_H

#include <IJackClientInterface.h>
namespace android {

/**
 * \brief An interface version 2 for a JACK client
 * 
 * It is used for making Jack client on the APA client.
 */
class IJackClientInterfaceV2 : public IJackClientInterface {
	public:

		/**
		 * Constructor
		 */
		IJackClientInterfaceV2();

		/**
		 * Destructor
		 */
		virtual ~IJackClientInterfaceV2();

		/**
		 * Get the Jack Client Name @n
		 * @param name the SapaProcessor's full name. It is the unique name of all client.
		 * @return the Jack Client Name which is matched with the name parameter.
		 */
		virtual char* getJackClientName(const char* name) = 0;

		/**
		 * Enable/Disable the ByPass of jack client@n
		 * It will be called when user call SapaProcessor.setByPassEnabled().@n
		 * @param enable 
		 * @return void
		 */
		virtual void setByPassEnabled(bool enable) = 0;
};

};

#endif // ANDROID_JACK_CLIENT_INTERFACE_H


